/* Angst - An active sniffer
 * By Patroklos Argyroudis <argp@bsd.gr>
 *
 * A simple active sniffer, based on libpcap and libnet.  Dumps into a file 
 * the payload of all the TCP packets received on the specified ports.  Also, 
 * it floods the local network with random MAC addresses (like macof v. 1.1
 * by Ian Vitek), causing switches to send packets to all ports.  Made just
 * for testing purposes and fun, so it is still in an infancy state.  Only
 * compiled and tested on OpenBSD.  If you compile it on any other platform,
 * please contact me on the above email address.
 *
 * Compilation:		make
 * Static binary:	make static
 * Debug support:	make debug
 *
 * Greets to: Joy for support, discussion, and ideas.
 *	      Brat3 for discussion.
 *            Jackal for his libpcap based code, some years ago.
 */

#include <stdarg.h>
#include <libnet.h>
#include <pcap.h>

#define VERSION "0.2b"

/* the bpf program expression, change it if you want */
#define FILTER "tcp and (dst port 21 or dst port 23 or dst port 110 or dst port 143)"

#define SNAPLEN	3000	/* maximum number of bytes to capture */
#define TIMEOUT	1000	/* read timeout in milliseconds */

#define	BUFSIZE		8192	/* maximum captured bytes per connection */
#define	SMALLBUFF	256

#define FLOODSECS	180	/* every FLOODSECS we flood */
#define	MACPKTS		1000	/* flood MACPKTS number of packets */

#define LOGFILE	"./angst.log"

extern char *	ether_ntoa(struct ether_addr *);
void		xprintf(char *msg, ...);
void		init_buf(char x[], int size);
void		packetdump(char *user, struct pcap_pkthdr *pkthdr, u_char *pkt);
void		flooder(void);
void		catcher(int signal);
void		sig_flood(int signal);
void		usage(char *name);
int		find_header_length(int d);
int		daemonize(const char *path);

/* EOF */
